<?php
/*------------------------------------------------------------------------
# Yt K2 Category  - Version 1.1
# Copyright (C) 2011 SmartAddons.Com. All Rights Reserved.
# @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Author: SmartAddons.Com
# Websites: http://www.smartaddons.com/
 -------------------------------------------------------------------------*/
 
require_once ( JPath::clean(JPATH_SITE.'/components/com_k2/helpers/route.php') );
  

if (! class_exists("YtK2Category") ) {
class YtK2Category {
    var $items = array();
    var $category = array();  
	var $sub_category = array();  	
	var $limit_sub_category = 6;
	var $max_title = 25;
    var $customUrl = array();     
	var $arrcustomUrl = array(); 
	var $sort_order_field = 'published';
	var $thumb_width = '100';
	var $thumb_height = '100';
	var $sub_thumb_width = '50';
	var $sub_thumb_height = '50';
	var $web_url = '';	
    var $imagesource = 0;		
	var $resize_folder = '';
	var $url_to_resize = '';
	var $url_to_module = '';	
	var $thumbnail_mode = 0;
	var $sub_thumbnail_mode = 0;
	var $limit_title = 25;
	var $limit_sub_title = 25;
    
    function getList($module) {
            global $mainframe;            
            $arrcustomUrl = YtK2Category::getArrURL($this->customUrl);     
            require_once ( JPath::clean(JPATH_SITE.'/components/com_k2/helpers/route.php') );
            $co_params = &JComponentHelper::getParams('com_k2');            
            $user = &JFactory::getUser();
            $aid = $user->get('aid');
            $db = &JFactory::getDBO();               
            $jnow = &JFactory::getDate();
            $now = $jnow->toMySQL();
            $nullDate = $db->getNullDate();          
            $catids= ''; 
		    $sub_catids = '';
			$art_id = '';
				$arraycatid = ($this->category);    
				//var_dump($arraycatid); die;
				    $catids = array();    
				    if (!is_null ($arraycatid)){
                        if (!is_array($arraycatid)) {
                         $arraycatid = array($arraycatid);
                        }
                    
                    foreach ($arraycatid as $key=>$value){  // var_dump($value); die('tttttt'); 
				    $sql = "SELECT c.id FROM #__k2_categories as c";   
				    $sql .= " WHERE c.parent = 0" 
                         . " AND c.id = {$value}";	
					       
				        $db->setQuery($sql);									
                        $a = $db->loadObjectlist();    
                        //var_dump($a); die;
                        if (count($a)>0){
                        $catids[$key] = $a;                  
					    }                       
			         }  
                    } 
                    //var_dump($catids); die('0000');         
				    $k2catids = array();
					foreach ($catids as $key=>$value) { $firstval = current($value); 
					    $k2catids[$key]['catid'] = $firstval->id; 
					}  
				//var_dump($k2catids); die;
					
				
                   if (!is_null ($arraycatid)){
                        if (!is_array($arraycatid)) {
                         $arraycatid = array($arraycatid);
                        }
                        
                    foreach ($arraycatid as $key=>$value){    
                    $sql = "SELECT c.id FROM #__k2_categories as c";
                    $sql .= " WHERE c.parent != 0"
                         . " AND c.id = {$value}";    
                           
                        $db->setQuery($sql);                    
                        //echo $db->getQuery() . '<br/><br/>';                    
                        $a = $db->loadObjectlist(); 
                        if (count($a)>0){
                        $sub_catids[$key] = $a;                  
                        }  
                     }  
                    } 
                   if(!empty($sub_catids)) {
                   foreach($sub_catids as $key=>$value){ $firstval = current($value);
                    $art_id .= $firstval->id.',';
                    }
                      $art_id = substr($art_id,0,strlen($art_id)-1);
                   }
                         
                       
                  //  var_dump($art_id); die;
                 
			      if (!empty ($k2catids)){	
				  foreach ($k2catids as $key=>$value) {		
				      //$cats = YtK2Category::getSubCategories($value, true);
				      $sql = "SELECT c.* FROM #__k2_categories as c";
				      $sql .= " WHERE c.published = 1"
					       . " AND c.access IN(".implode(',', $user->authorisedLevels()).")"
                           . " AND c.trash = 0"						
					       . " AND c.id = {$value['catid']}"; 	
				  		     
				      $query = "SELECT c.* FROM #__k2_categories as c";
				      $query .= " WHERE c.published = 1"
						     . " AND c.access IN(".implode(',', $user->authorisedLevels()).")"
                             . " AND c.trash = 0"						
						     . " AND c.parent = {$value['catid']}"; 	
				   
                    if( !empty($art_id)) { 
                        $query .= " AND c.id IN (". $art_id .") ";
                    }  
                  
					switch ($this->sort_order_field)
					{                                    
						case 'ordering': $ordering = 'c.ordering DESC';
									  break;                
						
						case 'random': $ordering = 'RAND()';
									 break; 
						case 'name': 									 
						default:       $ordering = 'c.name DESC';                              
									 break;
					 }        
					  
					$query .= ' ORDER BY ' . $ordering;    		        
					$query .=  $this->limit_sub_category ? ' LIMIT ' . $this->limit_sub_category : '';
                   
					$db->setQuery($sql);					
                    $a = $db->loadObjectlist();
					$db->setQuery($query);										
                    $b = $db->loadObjectlist();			
					$category[$key][0] = $a;
					$category[$key][1] = $b;
                   }
                 }
				
               // var_dump($category); die('rrrrrr');   
                if(!empty($category)) {
				 foreach ($category as $key=>$item) {
				  $k2category = array();  	
				  foreach ($item[0] as $key1=>$value) {
				     $k2 = array(); 				  
                     if(array_key_exists($value->id,$arrcustomUrl))
                     {
                         $value->category_link = $arrcustomUrl[$value->id]; 
                     }
                     else 
                     {
                        $value->category_link = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($value->id.':'.urldecode($value->alias))));
                     } 
				     if(!isset($value->category_image) && file_exists('media/k2/categories/'.$value->image) && is_file('media/k2/categories/'.$value->image))   
				     {
				        $value->category_image = 'media/k2/categories/'.$value->image;
				     } 
				     else 
				     {
				        $value->category_image = '';
				     }
 
					 $value = YtK2Category::forcategoryImage($value);		
					 if (!file_exists($value->category_image))
					 {
					 $value->category_image = 'modules/'.$module->module.'/images/no_image.gif';
					 }				 
					 $value->category_image = YtK2Category::categorythumbmode($value->category_image, $this->thumb_width, $this->thumb_height, $this->thumbnail_mode);		
					// var_dump($value->category_image); die;	
					   if (!isset($value->sub_title)) {
						$value->sub_title = $this->cutStr($value->name, $this->limit_title);
					}    
				 
				     $k2['category_id'] = $value->id;
				     $k2['category_name'] = $value->name;	
				     $k2['sub_title'] 	= $value->sub_title;	
				     $k2['category_description'] = $this->removeImage($value->description);
				     $k2['category_parent'] = $value->parent;				
				     $k2['category_thumb'] = $value->category_image;
				     $k2['category_link'] = $value->category_link;
			         $k2category[] = $k2;
					} 
				      $item[0] = $k2category;			
				     
				     //var_dump($item[0]); die;	
				      $k2sub_category = array(); 
				      foreach ($item[1] as $key1=>$value) { 
				      $query = "SELECT i.id FROM #__k2_items as i";
				      $query .= " WHERE i.access IN(".implode(',', $user->authorisedLevels()).")"
                             . " AND i.trash = 0"						
						     . " AND i.catid = {$value->id}"; 
				      $db->setQuery($query);					
					    //echo $db->getQuery() . '<br/><br/>';					
                      $a = $db->loadObjectlist();
				      
				      $k2 = array();   
                  
                      if(array_key_exists($value->id,$arrcustomUrl))
                      {
                         $value->category_link = $arrcustomUrl[$value->id]; 
                      }
                      else 
                      {
                         $value->category_link = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($value->id.':'.urldecode($value->alias))));
                      } 
					  $value->count_articles = count($a);
					  if(!isset($value->category_image) && file_exists('media/k2/categories/'.$value->image) && is_file('media/k2/categories/'.$value->image))   
				
					  {
					     $value->category_image = 'media/k2/categories/'.$value->image;
					  }else 
					  {
					     $value->category_image = '';
					  }
				
				     $value = YtK2Category::forcategoryImage($value);	
				     if (!file_exists($value->category_image))
				     {
				     $value->category_image = 'modules/'.$module->module.'/images/no_image.gif';
				     }	
				     $value->category_image = YtK2Category::categorythumbmode($value->category_image, $this->sub_thumb_width, $this->sub_thumb_height, $this->sub_thumbnail_mode);										
				
				     if (!isset($value->sub_title)) {
					    $value->sub_title = $this->cutStr($value->name, $this->limit_sub_title);
				     }   
          		     $k2['category_id'] = $value->id;
				     $k2['category_name'] = $value->name;	
				     $k2['sub_title'] = $value->sub_title;	
				     $k2['category_description'] = $this->removeImage($value->description);
				     $k2['category_parent'] = $value->parent;				
				     $k2['category_thumb'] = $value->category_image;
				     $k2['category_link'] = $value->category_link;
				     $k2['count_articles'] = $value->count_articles;
			         $k2sub_category[] = $k2;
					} 
				    $item[1] = $k2sub_category;	   				
					$sub_category[$key][0] = $item[0];
					$sub_category[$key][1] = $item[1];
					}
					//var_dump($sub_category); die('fsfsfafasfa');					
					return $sub_category; 
                 }        
                   
            }    
                     
		
		    function forcategoryImage( &$item ){           
            $regex1 = "/\<img.*\/\>/";           
            $item->description = trim($item->description);
            $content = $item->description;                      
            if( $item->category_image != '' ){                
                return $item;
            }                                 
            
            preg_match ( "#<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>#iU" , $content, $matches); 
            $images = (count($matches)) ? $matches : array();
            if (count($images)){                
                $item->category_image = $images[1];
            } else {                
                $item->category_image = '';    
            }
            
			 $item->description = preg_replace( $regex1, '', $item->description );
			 return $item; die;
			 //var_dump($item); die;
			}
		
			function categorythumbmode ($image, $image_width, $image_height, $image_mode) {	
				if (!isset($category_thumb) && ($image != '')) {
						$category_thumb = $this->processcategoryImage($image, $image_width, $image_height, $image_mode);    
					}
					else {
						$category_thumb = '';
					}   
				return $category_thumb;
				}
			function removeImage($str) {
			$regex1 = "/\<img[^\>]*>/";
			$str = preg_replace ( $regex1, '', $str );
			$regex1 = "/<div class=\"mosimage\".*<\/div>/";
			$str = preg_replace ( $regex1, '', $str );
			$str = trim ( $str );
			
			return $str;
			}
			function getArrURL($customUrl) {     
			$arrUrl = array();
			$tmp = explode("\n", trim($customUrl));            
			foreach( $tmp as $strTmp){
            $pos = strpos($strTmp, ":");
            if($pos >=0){
                $tmpKey = substr($strTmp, 0, $pos);
                $key = trim($tmpKey);
                $tmpLink = substr($strTmp, $pos+1, strlen($strTmp)-$pos);
                $haveHttp =  strpos(trim($tmpLink), "http://");
                //var_dump($haveHttp);die;                   
                if($haveHttp<0 || ($haveHttp !== false) ){
                    $link = trim($tmpLink);
                }else{
                    $link = "http://" . trim($tmpLink);
                }
                $arrUrl[$key] = $link;
            }  
			}            
			return $arrUrl;
			}

			function filterParams( $string ) {
				$string = html_entity_decode($string, ENT_QUOTES);
				$regex = "/\s*([^=\s]+)\s*=\s*('([^']*)'|\"([^\"]*)\"|([^\s]*))/";
				 $params = null;
				 if(preg_match_all($regex, $string, $matches) ){
						for ($i=0;$i<count($matches[1]);$i++){ 
						  $key      = $matches[1][$i];
						  $value = $matches[3][$i]?$matches[3][$i]:($matches[4][$i]?$matches[4][$i]:$matches[5][$i]);
						  $params[$key] = $value;
						}
				  }
				  return $params;
			}
				 
			
			function unhtmlentities($string) 
			{
            $trans_tbl = array("&lt;" => "<", "&gt;" => ">", "&amp;" => "&");
            return strtr($string, $trans_tbl);
			}
			
			
			function getFile($name, $modPath, $tmplPath) {
				if (file_exists(JPATH_SITE.DS.$tmplPath.$name)) {
					return $tmplPath.$name;
				}
				return $modPath.$name;
			}
			
		 function processcategoryImage($img, $width, $height, $image_mode) {
				 $imagSource = JPATH_SITE.DS. str_replace( '/', DS, $img );	
				
				if(file_exists($imagSource) && is_file($imagSource)){    
				if ($image_mode == 0) {
					return $this->resizeImage($img, $width, $height);
				} else {
					return $this->cropImage($img, $width, $height);
				}
				} else{

						return '';
				}    
				}
	
    function resizeImage($imagePath, $width, $height) {
        global $module;
                
        $folderPath = $this->resize_folder;
         
         if(!JFolder::exists($folderPath)){
                 JFolder::create($folderPath);     
         }
         
         $nameImg = str_replace('/','',strrchr($imagePath,"/"));
            
         $ext = substr($nameImg, strrpos($nameImg, '.'));
        
         $file_name = substr($nameImg, 0,  strrpos($nameImg, '.'));
        
         $nameImg = $file_name . "_" . $width . "_" . $height .  $ext;
         
         
         if(!JFile::exists($folderPath.DS.$nameImg)){
             $image = new SimpleImage();
               $image->load($imagePath);
               $image->resize($width,$height);
                $image->save($folderPath.DS.$nameImg);
         }else{
                  list($info_width, $info_height) = @getimagesize($folderPath.DS.$nameImg);
                  if($width!=$info_width||$height!=$info_height){
                       $image = new SimpleImage();
                       $image->load($imagePath);
                       $image->resize($width,$height);
                        $image->save($folderPath.DS.$nameImg);
                  }
         }
            return $this->url_to_resize . $nameImg;
    }
    
    function cropImage($imagePath, $width, $height) {
        global $module;
        
        $folderPath = $this->resize_folder;
         
        if(!JFolder::exists($folderPath)){
                 JFolder::create($folderPath);     
        }
         
         $nameImg = str_replace('/','',strrchr($imagePath,"/"));
            
         $ext = substr($nameImg, strrpos($nameImg, '.'));
        
         $file_name = substr($nameImg, 0,  strrpos($nameImg, '.'));
        
         $nameImg = $file_name . "_" . $width . "_" . $height .  $ext;    
         
         if(!JFile::exists($folderPath.DS.$nameImg)){
             $image = new SimpleImage();
               $image->load($imagePath);
               $image->crop($width,$height);
                $image->save($folderPath.DS.$nameImg);
         }else{
                  list($info_width, $info_height) = @getimagesize($folderPath.DS.$nameImg);
                  if($width!=$info_width||$height!=$info_height){
                       $image = new SimpleImage();
                       $image->load($imagePath);
                       $image->crop($width,$height);
                        $image->save($folderPath.DS.$nameImg);
                  }
         }
         
            return $this->url_to_resize . $nameImg;
    }
    
    /*Cut string*/
    function cutStr( $str, $number){
        //If length of string less than $number
        $str = strip_tags($str);
        if(strlen($str) <= $number){
            return $str;
        }
        $str = substr($str,0,$number);
    
        $pos = strrpos($str,' ');
    
        return substr($str,0,$pos).'...';
    }
    
}
}
if (! class_exists("SimpleImage") ) {
class SimpleImage {
   var $image;
   var $image_type;
 
   function load($filename) {
    
      $image_info = getimagesize($filename);
      $this->image_type = $image_info[2];
          
         
      if( $this->image_type == IMAGETYPE_JPEG ) {
         $this->image = imagecreatefromjpeg($filename);
      } elseif( $this->image_type == IMAGETYPE_GIF ) {
         $this->image = imagecreatefromgif($filename);
      } elseif( $this->image_type == IMAGETYPE_PNG ) {
         $this->image = imagecreatefrompng($filename);
      }
   
   }
   function save($filename, $image_type=IMAGETYPE_JPEG, $compression=100, $permissions=null) {
      if ($filename) {         
      if( $image_type == IMAGETYPE_JPEG ) {
         imagejpeg($this->image,$filename,$compression);
      } elseif( $image_type == IMAGETYPE_GIF ) {
         imagegif($this->image,$filename);         
      } elseif( $image_type == IMAGETYPE_PNG ) {
         imagepng($this->image,$filename);
      }   
      if( $permissions != null) {
         chmod($filename,$permissions);
      }
	  }
   }
   function output($image_type=IMAGETYPE_JPEG) {
      if( $image_type == IMAGETYPE_JPEG ) {
         imagejpeg($this->image);
      } elseif( $image_type == IMAGETYPE_GIF ) {
         imagegif($this->image);         
      } elseif( $image_type == IMAGETYPE_PNG ) {
         imagepng($this->image);
      }   
   }
   function getWidth() {
      return imagesx($this->image);
   }
   function getHeight() {
      return imagesy($this->image);
   }
   function resizeToHeight($height) {
      $ratio = $height / $this->getHeight();
      $width = $this->getWidth() * $ratio;
      $this->resize($width,$height);
   }
   function resizeToWidth($width) {
      $ratio = $width / $this->getWidth();
      $height = $this->getheight() * $ratio;
      $this->resize($width,$height);
   }
   function scale($scale) {
      $width = $this->getWidth() * $scale/100;
      $height = $this->getheight() * $scale/100; 
      $this->resize($width,$height);
   }
   function resize($width,$height) {
      $new_image = imagecreatetruecolor($width, $height);
      imagecopyresampled($new_image    , $this->image, 0, 0, 0, 0, $width, $height, $this->getWidth(), $this->getHeight());
      $this->image = $new_image; 
   }    
   function getbeginWidth($width){
   $k = $this->getWidth();
   $x1 = ($k - $width)/2;
   return $x1;
   }
   function getbeginHeight($height){
   $k = $this->getHeight();
   $y1 = ($k - $height)/2;
   return $y1;
   }
   function crop($width,$height) {
      $new_image = imagecreatetruecolor($width, $height);
      imagecopyresampled($new_image, $this->image, 0, 0, $this->getbeginWidth($width), $this->getbeginHeight($height),  $width, $height, $width, $height);
      $this->image = $new_image;   
   }   
}
}

?>
